/**
 * Created by IntelliJ IDEA.
 * User: jgervasio
 * Date: Feb 23, 2004
 * Time: 12:11:58 PM
 * To change this template use Options | File Templates.
 */
package j3d.cr325;


import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.geometry.Box;
import com.sun.j3d.utils.geometry.Cylinder;
import com.sun.j3d.utils.geometry.Primitive;
import com.sun.j3d.utils.geometry.Sphere;
import j3d.KeyBehavior;
import j3d.Utils;

import javax.media.j3d.*;
import javax.vecmath.*;
import java.applet.Applet;
import java.awt.*;


//   BillboardApp renders a simple landscape with billboard animated trees

public class Levitown extends Applet {

    public BranchGroup getSceneBranchGroup(TransformGroup tg) {

        BranchGroup bg = new BranchGroup();
        bg.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        bg.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);

        Vector3f translate = new Vector3f();
        Transform3D t3d = new Transform3D();

        BoundingSphere bs = new BoundingSphere();
        bs.setRadius(10);

        bg.addChild(Shapes.getLand());

        addTrees(translate, t3d, bs, bg);
        addHouses(translate, t3d, bs, bg);

        raiseViewAboveGround(translate, t3d, tg);
        KeyBehavior keyNavBeh = new KeyBehavior(gunXfmGrp, tg);
        //KeyNavigatorBehavior keyNavBeh = new KeyNavigatorBehavior(tg);
        keyNavBeh.setSchedulingBounds(new BoundingSphere(new Point3d(), 10000.0));
        bg.addChild(keyNavBeh);

        bg.addChild(Target.getTargetGroup());
        bg.addChild(buildGun());
        return bg;
    } // end of CreateSceneGraph method of BillboardApp

    /**
     * This builds the gun geometry.
     * It uses box and cylinder primitives and sets up a
     * transform group so that we can rotate the gun.
     */
    protected BranchGroup buildGun() {
        BranchGroup theGun = new BranchGroup();
        Appearance gunApp = new Appearance();
        Color3f ambientColour = new Color3f(0.5f, 0.5f, 0.5f);
        Color3f emissiveColour = new Color3f(0.0f, 0.0f, 0.0f);
        Color3f specularColour = new Color3f(1.0f, 1.0f, 1.0f);
        Color3f diffuseColour = new Color3f(0.5f, 0.5f, 0.5f);
        float shininess = 20.0f;
        gunApp.setMaterial(new Material(ambientColour, emissiveColour,
                diffuseColour, specularColour, shininess));
        TransformGroup init = new TransformGroup();
        TransformGroup barrel = new TransformGroup();
        Transform3D gunXfm = new Transform3D();
        Transform3D barrelXfm = new Transform3D();
        barrelXfm.set(new Vector3d(0.0, -2.0, 0.0));
        barrel.setTransform(barrelXfm);
        Matrix3d gunXfmMat = new Matrix3d();
        gunXfmMat.rotX(Math.PI / 2);
        Vector3d gunTranslation = new Vector3d(0.0, -.250, -5);
        gunXfm.set(gunXfmMat, gunTranslation, 1.0);
        init.setTransform(gunXfm);
        gunXfmGrp.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        gunXfmGrp.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
        gunXfmGrp.addChild(new Box(1.0f, 1.0f, 0.5f, gunApp));
        barrel.addChild(new Cylinder(0.3f, 4.0f, gunApp));
        gunXfmGrp.addChild(barrel);
        theGun.addChild(init);
        init.addChild(gunXfmGrp);
        return theGun;
    }

    TransformGroup gunXfmGrp = new TransformGroup();

    private void raiseViewAboveGround(Vector3f translate, Transform3D t3D, TransformGroup tg) {
        translate.set(0.0f, 0.3f, 0.0f);
        t3D.setTranslation(translate);
        tg.setTransform(t3D);
    }

    private void addHouses(Vector3f translate,
                           Transform3D t3D,
                           BoundingSphere bSphere,
                           BranchGroup bg) {
        SharedGroup share = new SharedGroup();

        share.addChild(Shapes.getHouses());

        float position[][] = {{0.0f, 0f, -2.0f},
                              {3.0f, 0f, 0.0f},
                              {3.0f, 0f, 4.0f},
                              {4.0f, 0f, -8.0f},
                              {6.0f, 0f, -25.0f},
                              {-6.0f, 0f, 25.0f},
                              {-6.0f, 0f, 15.0f},
                              {6.0f, 0f, 1.0f}};

        placeStuff(position, translate, t3D, bSphere, bg, share);
    }

    private void addTrees(Vector3f translate,
                          Transform3D t3D,
                          BoundingSphere bSphere,
                          BranchGroup bg) {
        SharedGroup share = new SharedGroup();
        share.addChild(Shapes.getTrees());

        float position[][] = {{0.0f, 0f, -3.0f},
                              {6.0f, 0f, 0.0f},
                              {6.0f, 0f, 6.0f},
                              {3.0f, 0f, -10.0f},
                              {13.0f, 0f, -30.0f},
                              {-13.0f, 0f, 30.0f},
                              {-13.0f, 0f, 23.0f},
                              {13.0f, 0f, 3.0f}};

        placeStuff(position, translate, t3D, bSphere, bg, share);
    }

    private void placeStuff(float[][] position,
                            Vector3f translate,
                            Transform3D t3D,
                            BoundingSphere bSphere,
                            BranchGroup bg,
                            SharedGroup share) {
        TransformGroup TGT;
        TransformGroup TGR;
        Billboard billboard;
        for (int i = 0; i < position.length; i++) {
            translate.set(position[i]);
            t3D.setTranslation(translate);
            TGT = new TransformGroup(t3D);
            TGR = new TransformGroup();
            TGR.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
            billboard = new Billboard(TGR);
            billboard.setSchedulingBounds(bSphere);
            billboard.setAlignmentMode(Billboard.ROTATE_ABOUT_POINT);
            bg.addChild(TGT);
            bg.addChild(billboard);
            TGT.addChild(TGR);
            TGR.addChild(new Link(share));
        }
    }
    private Locale constructViewBranch(View myView) {

         //First, we create the necessary coordinate systems
         //(VirtualUniverse, Locale), container nodes
         //(BranchGroup, TransformGroup), and platform which
         //determines our viewing position and direction (ViewPlatform).
         VirtualUniverse myUniverse = new VirtualUniverse();
         Locale myLocale = new Locale(myUniverse);
         BranchGroup myBranchGroup = new BranchGroup();
         TransformGroup myTransformGroup = new TransformGroup();
         ViewPlatform myViewPlatform = new ViewPlatform();

         //Next, we insert the platform into the transform group,
         //the transform group into the branch group, and the branch
         //group into the locale's branch graph portion of the
         //scene graph.
         myTransformGroup.addChild(myViewPlatform);
         myBranchGroup.addChild(myTransformGroup);
         myLocale.addBranchGraph(myBranchGroup);

         //Finally, we attach our view to the view platform and we
         //return a reference to our new universe.  We are ready to
         //render 3D content!
         myView.attachViewPlatform(myViewPlatform);
         return(myLocale);
       }

    private View constructView(Canvas3D myCanvas3D) {
        View myView = new View();
        myView.addCanvas3D(myCanvas3D);
        myView.setPhysicalBody(new PhysicalBody());
        myView.setPhysicalEnvironment(new PhysicalEnvironment());
        return (myView);
    }
      private void constructContentBranch(Locale myLocale) {
     //We first create a regular 2D font, then from that a
     //3D font, 3D text, and 3D shape, in succession.  We use
     //the default constructors for FontExtrusion and Appearance.
     Font myFont = new Font("TimesRoman",Font.PLAIN,10);
     Font3D myFont3D = new Font3D(myFont,new FontExtrusion());
     Text3D myText3D = new Text3D(myFont3D, "The Midterm begins");
     Shape3D myShape3D = new Shape3D(myText3D, new Appearance());

     //We created a new branch group and transform group to hold
     //our content.  This time when we create the transform group,
     //however, we pass in a Transform3D to the transform group's
     //constructor.  This 3D transform has been manipulated
     //to perform the transformations we desire, which results
     //in those manipulations being carried out on all children
     //of the given transform group, in this case, our content.
     BranchGroup contentBranchGroup = new BranchGroup();
     Transform3D myTransform3D = new Transform3D();
     myTransform3D.setTranslation(new Vector3f(-2.0f,0.0f,-4.0f));
     myTransform3D.setScale(0.1);
    Transform3D tempTransform3D = new Transform3D();
     tempTransform3D.rotY(Math.PI/4.0d);
     myTransform3D.mul(tempTransform3D);
     TransformGroup contentTransformGroup = new TransformGroup(myTransform3D);

     //We add our child nodes and insert the branch group into
     //the live scene graph.  This results in Java 3D rendering
     //the content.
     contentTransformGroup.addChild(myShape3D);
     contentBranchGroup.addChild(contentTransformGroup);
     myLocale.addBranchGraph(contentBranchGroup);
   }
    public Levitown() {
        setLayout(new BorderLayout());
        Canvas3D c3d = Utils.getCanvas3D(this);
        add("Center", c3d);
        View myView = constructView(c3d);

     Locale myLocale = constructViewBranch(myView);
     constructContentBranch(myLocale);
        /*
        VirtualUniverse vu = new VirtualUniverse();
        //SimpleUniverse su = new SimpleUniverse(c3d);
        Locale l
                = new Locale(vu);
        BranchGroup bg = createBackground(this);

        //Transform3D t3d = new Transform3D();
        //viewingPlatform.getLocalToVworld(t3d);
        TransformGroup vpt = new TransformGroup();
        bg.addChild(getSceneBranchGroup(vpt));
        l.addBranchGraph(bg);
        */
    }

    BoundingSphere getBackgroundBoundingSphere() {
        return new BoundingSphere(new Point3d(0.0, 0.0, 0.0), 2000.0);
    }

    public static BranchGroup createBackground(Levitown levitown) {
        // create a parent BranchGroup for the Background
        BranchGroup backgroundGroup = new BranchGroup();

        // create a new Background node
        Background back = new Background();

        // set the range of influence of the background
        back.setApplicationBounds(levitown.getBackgroundBoundingSphere());

        // create a BranchGroup that will hold
        // our Sphere geometry
        BranchGroup bgGeometry = new BranchGroup();

        // create the Sphere geometry with radius 1.0
        // we tell the Sphere to generate texture coordinates
        // to enable the texture image to be rendered
        // and because we are *inside* the Sphere we have to generate
        // Normal coordinates inwards or the Sphere will not be visible.
        Appearance appearance = new Appearance();
        appearance.setTexture(Utils.getMandleTexture(640, 480));
        Sphere sphere = new Sphere(.50f,
                Primitive.GENERATE_TEXTURE_COORDS |
                Primitive.GENERATE_NORMALS_INWARD,
                appearance);

        // start wiring everything together
        // add the Sphere to its parent BranchGroup
        bgGeometry.addChild(sphere);


        // assign the BranchGroup to the Background as geometry.
        back.setGeometry(bgGeometry);

        // add the Background node to its parent BranchGroup
        backgroundGroup.addChild(back);

        return backgroundGroup;
    }


    public static void main(String[] args) {
        new MainFrame(new Levitown(), 256, 256);
    } // end of main (method of BillboardApp)
}
